# CustomGBForce Class Reference

This class implements complex, multiple stage nonbonded interactions between particles. More...

Inheritance diagram for CustomGBForce:

List of all members.

## Public Member Functions

def | __del__
| __del__(self)
def | getNumParticles
| getNumParticles(self) -> int
def | getNumExclusions
| getNumExclusions(self) -> int
def | getNumPerParticleParameters
| getNumPerParticleParameters(self) -> int
def | getNumGlobalParameters
| getNumGlobalParameters(self) -> int
def | getNumTabulatedFunctions
| getNumTabulatedFunctions(self) -> int
def | getNumFunctions
| getNumFunctions(self) -> int
def | getNumComputedValues
| getNumComputedValues(self) -> int
def | getNumEnergyTerms
| getNumEnergyTerms(self) -> int
def | getNonbondedMethod
| getNonbondedMethod(self) -> NonbondedMethod
def | setNonbondedMethod
| setNonbondedMethod(self, NonbondedMethod method)
def | getCutoffDistance
| getCutoffDistance(self) -> double
def | setCutoffDistance
| setCutoffDistance(self, double distance)
def | addPerParticleParameter
| addPerParticleParameter(self, string name) -> int
def | getPerParticleParameterName
| getPerParticleParameterName(self, int index) -> string
def | setPerParticleParameterName
| setPerParticleParameterName(self, int index, string name)
def | addGlobalParameter
| addGlobalParameter(self, string name, double defaultValue) -> int
def | getGlobalParameterName
| getGlobalParameterName(self, int index) -> string
def | setGlobalParameterName
| setGlobalParameterName(self, int index, string name)
def | getGlobalParameterDefaultValue
| getGlobalParameterDefaultValue(self, int index) -> double
def | setGlobalParameterDefaultValue
| setGlobalParameterDefaultValue(self, int index, double defaultValue)
def | addParticle
| addParticle(self, vectord parameters) -> int
def | getParticleParameters
| getParticleParameters(self, int index)
def | setParticleParameters
| setParticleParameters(self, int index, vectord parameters)
def | addComputedValue
| addComputedValue(self, string name, string expression, ComputationType type) -> int
def | getComputedValueParameters
| getComputedValueParameters(self, int index)
def | setComputedValueParameters
| setComputedValueParameters(self, int index, string name, string expression, ComputationType type)
def | addEnergyTerm
| addEnergyTerm(self, string expression, ComputationType type) -> int
def | getEnergyTermParameters
| getEnergyTermParameters(self, int index)
def | setEnergyTermParameters
| setEnergyTermParameters(self, int index, string expression, ComputationType type)
def | addExclusion
| addExclusion(self, int particle1, int particle2) -> int
def | getExclusionParticles
| getExclusionParticles(self, int index)
def | setExclusionParticles
| setExclusionParticles(self, int index, int particle1, int particle2)
def | addTabulatedFunction
| addTabulatedFunction(self, string name, TabulatedFunction function) -> int
def | getTabulatedFunction
| getTabulatedFunction(self, int index) -> TabulatedFunction getTabulatedFunction(self, int index) -> TabulatedFunction
def | getTabulatedFunctionName
| getTabulatedFunctionName(self, int index) -> string
def | addFunction
| addFunction(self, string name, vectord values, double min, double max) -> int
def | getFunctionParameters
| getFunctionParameters(self, int index)
def | setFunctionParameters
| setFunctionParameters(self, int index, string name, vectord values, double min, double max)
def | updateParametersInContext
| updateParametersInContext(self, Context context)
def | __init__
| __init__(self) -> CustomGBForce __init__(self, CustomGBForce other) -> CustomGBForce

## Public Attributes

| this

## Static Public Attributes

| NoCutoff = _openmm.CustomGBForce_NoCutoff
| CutoffNonPeriodic = _openmm.CustomGBForce_CutoffNonPeriodic
| CutoffPeriodic = _openmm.CustomGBForce_CutoffPeriodic
| SingleParticle = _openmm.CustomGBForce_SingleParticle
| ParticlePair = _openmm.CustomGBForce_ParticlePair
| ParticlePairNoExclusions = _openmm.CustomGBForce_ParticlePairNoExclusions

## Detailed Description

This class implements complex, multiple stage nonbonded interactions between particles.

It is designed primarily for implementing Generalized Born implicit solvation models, although it is not strictly limited to that purpose. The interaction is specified as a series of computations, each defined by an arbitrary algebraic expression. It also allows tabulated functions to be defined and used with the computations. It optionally supports periodic boundary conditions and cutoffs for long range interactions.

The computation consists of calculating some number of per-particle computed values, followed by one or more energy terms. A computed value is a scalar value that is computed for each particle in the system. It may depend on an arbitrary set of global and per-particle parameters, and well as on other computed values that have been calculated before it. Once all computed values have been calculated, the energy terms and their derivatives are evaluated to determine the system energy and particle forces. The energy terms may depend on global parameters, per-particle parameters, and per-particle computed values.

When specifying a computed value or energy term, you provide an algebraic expression to evaluate and a computation type describing how the expression is to be evaluated. There are two main types of computations:

- Single Particle: The expression is evaluated once for each particle in the System. In the case of a computed value, this means the value for a particle depends only on other properties of that particle (its position, parameters, and other computed values). In the case of an energy term, it means each particle makes an independent contribution to the System energy.

- Particle Pairs: The expression is evaluated for every pair of particles in the system. In the case of a computed value, the value for a particular particle is calculated by pairing it with every other particle in the system, evaluating the expression for each pair, and summing them. For an energy term, each particle pair makes an independent contribution to the System energy. (Note that energy terms are assumed to be symmetric with respect to the two interacting particles, and therefore are evaluated only once per pair. In contrast, expressions for computed values need not be symmetric and therefore are calculated twice for each pair: once when calculating the value for the first particle, and again when calculating the value for the second particle.)

Be aware that, although this class is extremely general in the computations it can define, particular Platforms may only support more restricted types of computations. In particular, all currently existing Platforms require that the first computed value must be a particle pair computation, and all computed values after the first must be single particle computations. This is sufficient for most Generalized Born models, but might not permit some other types of calculations to be implemented.

This is a complicated class to use, and an example may help to clarify it. The following code implements the OBC variant of the GB/SA solvation model, using the ACE approximation to estimate surface area:

``

    CustomGBForce* custom = new CustomGBForce();
    custom->addPerParticleParameter("q");
    custom->addPerParticleParameter("radius");
    custom->addPerParticleParameter("scale");
    custom->addGlobalParameter("solventDielectric", obc->getSolventDielectric());
    custom->addGlobalParameter("soluteDielectric", obc->getSoluteDielectric());
    custom->addComputedValue("I", "step(r+sr2-or1)*0.5*(1/L-1/U+0.25*(1/U^2-1/L^2)*(r-sr2*sr2/r)+0.5*log(L/U)/r+C);"
    "U=r+sr2;"
    "C=2*(1/or1-1/L)*step(sr2-r-or1);"
    "L=max(or1, D);"
    "D=abs(r-sr2);"
    "sr2 = scale2*or2;"
    "or1 = radius1-0.009; or2 = radius2-0.009", CustomGBForce.ParticlePairNoExclusions);
    custom->addComputedValue("B", "1/(1/or-tanh(1*psi-0.8*psi^2+4.85*psi^3)/radius);"
    "psi=I*or; or=radius-0.009", CustomGBForce.SingleParticle);
    custom->addEnergyTerm("28.3919551*(radius+0.14)^2*(radius/B)^6-0.5*138.935456*(1/soluteDielectric-1/solventDielectric)*q^2/B",
    CustomGBForce.SingleParticle);
    custom->addEnergyTerm("-138.935456*(1/soluteDielectric-1/solventDielectric)*q1*q2/f;"
    "f=sqrt(r^2+B1*B2*exp(-r^2/(4*B1*B2)))", CustomGBForce.ParticlePair);

It begins by defining three per-particle parameters (charge, atomic radius, and scale factor) and two global parameters (the dielectric constants for the solute and solvent). It then defines a computed value "I" of type ParticlePair. The expression for evaluating it is a complicated function of the distance between each pair of particles (r), their atomic radii (radius1 and radius2), and their scale factors (scale1 and scale2). Very roughly speaking, it is a measure of the distance between each particle and other nearby particles.

Next a computation is defined for the Born Radius (B). It is computed independently for each particle, and is a function of that particle's atomic radius and the intermediate value I defined above.

Finally, two energy terms are defined. The first one is computed for each particle and represents the surface area term, as well as the self interaction part of the polarization energy. The second term is calculated for each pair of particles, and represents the screening of electrostatic interactions by the solvent.

After defining the force as shown above, you should then call addParticle() once for each particle in the System to set the values of its per-particle parameters (q, radius, and scale). The number of particles for which you set parameters must be exactly equal to the number of particles in the System, or else an exception will be thrown when you try to create a Context. After a particle has been added, you can modify its parameters by calling setParticleParameters(). This will have no effect on Contexts that already exist unless you call updateParametersInContext().

CustomGBForce also lets you specify "exclusions", particular pairs of particles whose interactions should be omitted from calculations. This is most often used for particles that are bonded to each other. Even if you specify exclusions, however, you can use the computation type ParticlePairNoExclusions to indicate that exclusions should not be applied to a particular piece of the computation.

Expressions may involve the operators + (add), - (subtract), * (multiply), / (divide), and ^ (power), and the following functions: sqrt, exp, log, sin, cos, sec, csc, tan, cot, asin, acos, atan, sinh, cosh, tanh, erf, erfc, min, max, abs, step, delta. All trigonometric functions are defined in radians, and log is the natural logarithm. step(x) = 0 if x is less than 0, 1 otherwise. delta(x) = 1 if x is 0, 0 otherwise. In expressions for particle pair calculations, the names of per-particle parameters and computed values have the suffix "1" or "2" appended to them to indicate the values for the two interacting particles. As seen in the above example, an expression may also involve intermediate quantities that are defined following the main expression, using ";" as a separator.

In addition, you can call addTabulatedFunction() to define a new function based on tabulated values. You specify the function by creating a TabulatedFunction object. That function can then appear in expressions.

## Member Function Documentation

def __del__ | ( |  | self | ) |

__del__(self)

Reimplemented from Force.

def __init__ | ( |  | self,
|  |  | args |
| ) |  |  |

__init__(self) -> CustomGBForce __init__(self, CustomGBForce other) -> CustomGBForce

Create a CustomGBForce.

def addComputedValue | ( |  | self,
|  |  | args |
| ) |  |  |

addComputedValue(self, string name, string expression, ComputationType type) -> int

Add a computed value to calculate for each particle.

Parameters:

  | name | the name of the value

  expression

  an algebraic expression to evaluate when calculating the computed value. If the ComputationType is SingleParticle, the expression is evaluated independently for each particle, and may depend on its x, y, and z coordinates, as well as the per-particle parameters and previous computed values for that particle. If the ComputationType is ParticlePair or ParticlePairNoExclusions, the expression is evaluated once for every other particle in the system and summed to get the final value. In the latter case, the expression may depend on the distance r between the two particles, and on the per-particle parameters and previous computed values for each of them. Append "1" to a variable name to indicate the parameter for the particle whose value is being calculated, and "2" to indicate the particle it is interacting with.

  | type | the method to use for computing this value

def addEnergyTerm | ( |  | self,
|  |  | args |
| ) |  |  |

addEnergyTerm(self, string expression, ComputationType type) -> int

Add a term to the energy computation.

Parameters:

  expression

  an algebraic expression to evaluate when calculating the energy. If the ComputationType is SingleParticle, the expression is evaluated once for each particle, and may depend on its x, y, and z coordinates, as well as the per-particle parameters and computed values for that particle. If the ComputationType is ParticlePair or ParticlePairNoExclusions, the expression is evaluated once for every pair of particles in the system. In the latter case, the expression may depend on the distance r between the two particles, and on the per-particle parameters and computed values for each of them. Append "1" to a variable name to indicate the parameter for the first particle in the pair and "2" to indicate the second particle in the pair.

  | type | the method to use for computing this value

def addExclusion | ( |  | self,
|  |  | args |
| ) |  |  |

addExclusion(self, int particle1, int particle2) -> int

Add a particle pair to the list of interactions that should be excluded.

Parameters:

  | particle1 | the index of the first particle in the pair
  | particle2 | the index of the second particle in the pair

def addFunction | ( |  | self,
|  |  | args |
| ) |  |  |

addFunction(self, string name, vectord values, double min, double max) -> int

Add a tabulated function that may appear in expressions.

def addGlobalParameter | ( |  | self,
|  |  | args |
| ) |  |  |

addGlobalParameter(self, string name, double defaultValue) -> int

Add a new global parameter that the interaction may depend on.

Parameters:

  | name | the name of the parameter
  | defaultValue | the default value of the parameter

def addParticle | ( |  | self,
|  |  | args |
| ) |  |  |

addParticle(self, vectord parameters) -> int

Add the nonbonded force parameters for a particle. This should be called once for each particle in the System. When it is called for the i'th time, it specifies the parameters for the i'th particle.

Parameters:

  | parameters | the list of parameters for the new particle

def addPerParticleParameter | ( |  | self,
|  |  | args |
| ) |  |  |

addPerParticleParameter(self, string name) -> int

Add a new per-particle parameter that the interaction may depend on.

Parameters:

  | name | the name of the parameter

def addTabulatedFunction | ( |  | self,
|  |  | args |
| ) |  |  |

addTabulatedFunction(self, string name, TabulatedFunction function) -> int

Add a tabulated function that may appear in expressions.

Parameters:

  | name | the name of the function as it appears in expressions
  | function | a TabulatedFunction object defining the function. The TabulatedFunction should have been created on the heap with the "new" operator. The Force takes over ownership of it, and deletes it when the Force itself is deleted.

def getComputedValueParameters | ( |  | self,
|  |  | args |
| ) |  |  |

getComputedValueParameters(self, int index)

Get the properties of a computed value.

Parameters:

  | index | the index of the computed value for which to get parameters
  | name | the name of the value

  expression

  an algebraic expression to evaluate when calculating the computed value. If the ComputationType is SingleParticle, the expression is evaluated independently for each particle, and may depend on its x, y, and z coordinates, as well as the per-particle parameters and previous computed values for that particle. If the ComputationType is ParticlePair or ParticlePairNoExclusions, the expression is evaluated once for every other particle in the system and summed to get the final value. In the latter case, the expression may depend on the distance r between the two particles, and on the per-particle parameters and previous computed values for each of them. Append "1" to a variable name to indicate the parameter for the particle whose value is being calculated, and "2" to indicate the particle it is interacting with.

  | type | the method to use for computing this value

def getCutoffDistance | ( |  | self | ) |

getCutoffDistance(self) -> double

Get the cutoff distance (in nm) being used for nonbonded interactions. If the NonbondedMethod in use is NoCutoff, this value will have no effect.

def getEnergyTermParameters | ( |  | self,
|  |  | args |
| ) |  |  |

getEnergyTermParameters(self, int index)

Get the properties of a term to the energy computation.

Parameters:

  | index | the index of the term for which to get parameters

  expression

  an algebraic expression to evaluate when calculating the energy. If the ComputationType is SingleParticle, the expression is evaluated once for each particle, and may depend on its x, y, and z coordinates, as well as the per-particle parameters and computed values for that particle. If the ComputationType is ParticlePair or ParticlePairNoExclusions, the expression is evaluated once for every pair of particles in the system. In the latter case, the expression may depend on the distance r between the two particles, and on the per-particle parameters and computed values for each of them. Append "1" to a variable name to indicate the parameter for the first particle in the pair and "2" to indicate the second particle in the pair.

  | type | the method to use for computing this value

def getExclusionParticles | ( |  | self,
|  |  | args |
| ) |  |  |

getExclusionParticles(self, int index)

Get the particles in a pair whose interaction should be excluded.

Parameters:

  | index | the index of the exclusion for which to get particle indices
  | particle1 | the index of the first particle in the pair
  | particle2 | the index of the second particle in the pair

def getFunctionParameters | ( |  | self,
|  |  | args |
| ) |  |  |

getFunctionParameters(self, int index)

Get the parameters for a tabulated function that may appear in expressions.

def getGlobalParameterDefaultValue | ( |  | self,
|  |  | args |
| ) |  |  |

getGlobalParameterDefaultValue(self, int index) -> double

Get the default value of a global parameter.

Parameters:

  | index | the index of the parameter for which to get the default value

def getGlobalParameterName | ( |  | self,
|  |  | args |
| ) |  |  |

getGlobalParameterName(self, int index) -> string

Get the name of a global parameter.

Parameters:

  | index | the index of the parameter for which to get the name

def getNonbondedMethod | ( |  | self | ) |

getNonbondedMethod(self) -> NonbondedMethod

Get the method used for handling long range nonbonded interactions.

def getNumComputedValues | ( |  | self | ) |

getNumComputedValues(self) -> int

Get the number of per-particle computed values the interaction depends on.

def getNumEnergyTerms | ( |  | self | ) |

getNumEnergyTerms(self) -> int

Get the number of terms in the energy computation.

def getNumExclusions | ( |  | self | ) |

getNumExclusions(self) -> int

Get the number of particle pairs whose interactions should be excluded.

def getNumFunctions | ( |  | self | ) |

getNumFunctions(self) -> int

Get the number of tabulated functions that have been defined.

def getNumGlobalParameters | ( |  | self | ) |

getNumGlobalParameters(self) -> int

Get the number of global parameters that the interaction depends on.

def getNumParticles | ( |  | self | ) |

getNumParticles(self) -> int

Get the number of particles for which force field parameters have been defined.

def getNumPerParticleParameters | ( |  | self | ) |

getNumPerParticleParameters(self) -> int

Get the number of per-particle parameters that the interaction depends on.

def getNumTabulatedFunctions | ( |  | self | ) |

getNumTabulatedFunctions(self) -> int

Get the number of tabulated functions that have been defined.

def getParticleParameters | ( |  | self,
|  |  | args |
| ) |  |  |

getParticleParameters(self, int index)

Get the nonbonded force parameters for a particle.

Parameters:

  | index | the index of the particle for which to get parameters
  | parameters | the list of parameters for the specified particle

def getPerParticleParameterName | ( |  | self,
|  |  | args |
| ) |  |  |

getPerParticleParameterName(self, int index) -> string

Get the name of a per-particle parameter.

Parameters:

  | index | the index of the parameter for which to get the name

def getTabulatedFunction | ( |  | self,
|  |  | args |
| ) |  |  |

getTabulatedFunction(self, int index) -> TabulatedFunction getTabulatedFunction(self, int index) -> TabulatedFunction

Get a reference to a tabulated function that may appear in expressions.

Parameters:

  | index | the index of the function to get

def getTabulatedFunctionName | ( |  | self,
|  |  | args |
| ) |  |  |

getTabulatedFunctionName(self, int index) -> string

Get the name of a tabulated function that may appear in expressions.

Parameters:

  | index | the index of the function to get

def setComputedValueParameters | ( |  | self,
|  |  | args |
| ) |  |  |

setComputedValueParameters(self, int index, string name, string expression, ComputationType type)

Set the properties of a computed value.

Parameters:

  | index | the index of the computed value for which to set parameters
  | name | the name of the value

  expression

  an algebraic expression to evaluate when calculating the computed value. If the ComputationType is SingleParticle, the expression is evaluated independently for each particle, and may depend on its x, y, and z coordinates, as well as the per-particle parameters and previous computed values for that particle. If the ComputationType is ParticlePair or ParticlePairNoExclusions, the expression is evaluated once for every other particle in the system and summed to get the final value. In the latter case, the expression may depend on the distance r between the two particles, and on the per-particle parameters and previous computed values for each of them. Append "1" to a variable name to indicate the parameter for the particle whose value is being calculated, and "2" to indicate the particle it is interacting with.

  | type | the method to use for computing this value

def setCutoffDistance | ( |  | self,
|  |  | args |
| ) |  |  |

setCutoffDistance(self, double distance)

Set the cutoff distance (in nm) being used for nonbonded interactions. If the NonbondedMethod in use is NoCutoff, this value will have no effect.

Parameters:

  | distance | the cutoff distance, measured in nm

def setEnergyTermParameters | ( |  | self,
|  |  | args |
| ) |  |  |

setEnergyTermParameters(self, int index, string expression, ComputationType type)

Set the properties of a term to the energy computation.

Parameters:

  | index | the index of the term for which to set parameters

  expression

  an algebraic expression to evaluate when calculating the energy. If the ComputationType is SingleParticle, the expression is evaluated once for each particle, and may depend on its x, y, and z coordinates, as well as the per-particle parameters and computed values for that particle. If the ComputationType is ParticlePair or ParticlePairNoExclusions, the expression is evaluated once for every pair of particles in the system. In the latter case, the expression may depend on the distance r between the two particles, and on the per-particle parameters and computed values for each of them. Append "1" to a variable name to indicate the parameter for the first particle in the pair and "2" to indicate the second particle in the pair.

  | type | the method to use for computing this value

def setExclusionParticles | ( |  | self,
|  |  | args |
| ) |  |  |

setExclusionParticles(self, int index, int particle1, int particle2)

Set the particles in a pair whose interaction should be excluded.

Parameters:

  | index | the index of the exclusion for which to set particle indices
  | particle1 | the index of the first particle in the pair
  | particle2 | the index of the second particle in the pair

def setFunctionParameters | ( |  | self,
|  |  | args |
| ) |  |  |

setFunctionParameters(self, int index, string name, vectord values, double min, double max)

Set the parameters for a tabulated function that may appear in expressions.

def setGlobalParameterDefaultValue | ( |  | self,
|  |  | args |
| ) |  |  |

setGlobalParameterDefaultValue(self, int index, double defaultValue)

Set the default value of a global parameter.

Parameters:

  | index | the index of the parameter for which to set the default value
  | name | the default value of the parameter

def setGlobalParameterName | ( |  | self,
|  |  | args |
| ) |  |  |

setGlobalParameterName(self, int index, string name)

Set the name of a global parameter.

Parameters:

  | index | the index of the parameter for which to set the name
  | name | the name of the parameter

def setNonbondedMethod | ( |  | self,
|  |  | args |
| ) |  |  |

setNonbondedMethod(self, NonbondedMethod method)

Set the method used for handling long range nonbonded interactions.

def setParticleParameters | ( |  | self,
|  |  | args |
| ) |  |  |

setParticleParameters(self, int index, vectord parameters)

Set the nonbonded force parameters for a particle.

Parameters:

  | index | the index of the particle for which to set parameters
  | parameters | the list of parameters for the specified particle

def setPerParticleParameterName | ( |  | self,
|  |  | args |
| ) |  |  |

setPerParticleParameterName(self, int index, string name)

Set the name of a per-particle parameter.

Parameters:

  | index | the index of the parameter for which to set the name
  | name | the name of the parameter

def updateParametersInContext | ( |  | self,
|  |  | args |
| ) |  |  |

updateParametersInContext(self, Context context)

Update the per-particle parameters in a Context to match those stored in this Force object. This method provides an efficient method to update certain parameters in an existing Context without needing to reinitialize it. Simply call setParticleParameters() to modify this object's parameters, then call updateParametersInState() to copy them over to the Context.

This method has several limitations. The only information it updates is the values of per-particle parameters. All other aspects of the Force (such as the energy function) are unaffected and can only be changed by reinitializing the Context. Also, this method cannot be used to add new particles, only to change the parameters of existing ones.

## Member Data Documentation

CutoffNonPeriodic = _openmm.CustomGBForce_CutoffNonPeriodic`[static]`

CutoffPeriodic = _openmm.CustomGBForce_CutoffPeriodic`[static]`

NoCutoff = _openmm.CustomGBForce_NoCutoff`[static]`

ParticlePair = _openmm.CustomGBForce_ParticlePair`[static]`

ParticlePairNoExclusions = _openmm.CustomGBForce_ParticlePairNoExclusions`[static]`

SingleParticle = _openmm.CustomGBForce_SingleParticle`[static]`

this

The documentation for this class was generated from the following file:

- openmm.py